<?php

automatic_feed_links();

function actuality_doctitle() {
    $site_name = get_bloginfo('name');
    $separator = '&#8212;';
        	
    if ( is_single() ) {
      $content = single_post_title('', FALSE);
    }
    elseif ( is_home() || is_front_page() ) { 
      $content = get_bloginfo('description');
    }
    elseif ( is_page() ) { 
      $content = single_post_title('', FALSE); 
    }
    elseif ( is_day() ) {
      //FIXME: Find out the source of this bug and remove it
      $content = the_time('\A\l\l \e\n\t\r\i\e\s \f\r\o\m F \t\h\e j\<\s\u\p\>S\<\/\s\u\p>, Y');
      $content .= ' ';
    }
    elseif ( is_month() ) {
      //FIXME: Find out the source of this bug and remove it
      $content = the_time('\A\l\l \e\n\t\r\i\e\s \f\r\o\m F, Y');
      $content .= ' ';
    }
    elseif ( is_year() ) {
      //FIXME: Find out the source of this bug and remove it
      $content = the_time('\A\l\l \e\n\t\r\i\e\s \f\r\o\m \t\h\e \y\e\a\r Y');
      $content .= ' ';
    }
    elseif ( is_search() ) { 
      $content = __('Search results for', 'thematic'); 
      $content .= ' \'' . wp_specialchars(stripslashes(get_search_query()), true) . '\'';
    }
    elseif ( is_category() ) {
      $content = __('All entries classified', 'thematic');
      $content .= ' \'' . single_cat_title("", false) . '\'';
    }
    elseif ( is_tag() ) {
    	if ( actuality_tag_query() != 'mu' )
	{
      		$content = __('All entries tagged', 'thematic');
      		$content .= ' \'' . actuality_tag_query() . '\'';
	}
	else $content = '&#181;Journal';
    }
    elseif ( is_404() ) { 
      $content = __('Content not found', 'thematic'); 
    }
    else { 
      $content = get_bloginfo('description');
    }

    if (get_query_var('paged')) {
      $content .= ' ' .$separator. ' ';
      $content .= 'Page';
      $content .= ' ';
      $content .= get_query_var('paged');
    }

    if($content) {
      if ( is_home() || is_front_page() ) {
          $elements = array(
            'site_name' => $site_name,
            'separator' => $separator,
            'content' => $content
          );
      }
      else {
          $elements = array(
            'content' => $content
          );
      }  
    } else {
      $elements = array(
        'site_name' => $site_name
      );
    }

    // Filters should return an array
    $elements = apply_filters('actuality_doctitle', $elements);
	
    // But if they don't, it won't try to implode
    if(is_array($elements)) {
      $doctitle = implode(' ', $elements);
    }
    else {
      $doctitle = $elements;
    }
    echo $doctitle;
} // end actuality_doctitle

function actuality_tag_query() {
	$nice_tag_query = get_query_var('tag'); // tags in current query
	$nice_tag_query = str_replace(' ', '+', $nice_tag_query); // get_query_var returns ' ' for AND, replace by +
	$tag_slugs = preg_split('%[,+]%', $nice_tag_query, -1, PREG_SPLIT_NO_EMPTY); // create array of tag slugs
	$tag_ops = preg_split('%[^,+]*%', $nice_tag_query, -1, PREG_SPLIT_NO_EMPTY); // create array of operators

	$tag_ops_counter = 0;
	$nice_tag_query = '';

	foreach ($tag_slugs as $tag_slug) { 
		$tag = get_term_by('slug', $tag_slug ,'post_tag');
		// prettify tag operator, if any
		if ($tag_ops[$tag_ops_counter] == ',') {
			$tag_ops[$tag_ops_counter] = ', ';
		} elseif ($tag_ops[$tag_ops_counter] == '+') {
			$tag_ops[$tag_ops_counter] = ' + ';
		}
		// concatenate display name and prettified operators
		$nice_tag_query = $nice_tag_query.$tag->name.$tag_ops[$tag_ops_counter];
		$tag_ops_counter += 1;
	}
	 return $nice_tag_query;
}

function truncate($string, $max = 30, $rep = '...') {
	if (strlen($string) <= ($max + strlen($rep))) {
		return $string;
	}
	$leave = $max - strlen ($rep);
	return substr_replace($string, $rep, $leave);
} 

function actuality_pick_by_tag($tag='spotlight', $limit=0) {
    $query_string = 'tag='.$tag.'&showposts='.$limit.'&orderby=rand';
    $picks = new WP_Query($query_string);
    while ($picks->have_posts()) {
	$picks->the_post();
	$title=the_title('', '', FALSE);
	echo '<li><a href="',the_permalink(),'" title="',the_title(),'">',truncate($title),'</a></li>';
    }
}

// Clean up header
remove_action('wp_head', 'rsd_link');
remove_action('wp_head', 'wlwmanifest_link');
remove_action('wp_head', 'wp_generator'); 

?>
